/* 
ZLib license:
Copyright (c) 2011 Dirk de la Hunt

This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.
*/

/*
This is the worst String implementation in the world (unproven), but simple enough to make life easier, and not cause too many issues
*/
#ifndef __CRAPPYSTRING_H_
#define __CRAPPYSTRING_H_

#include <string.h>

class CrappyString
{
protected:
	char *buffer;
	int   length;

protected:
	char* destroy()
	{
		delete [] buffer;
		buffer = 0;
		length = 0;
		return 0;
	}

public:
	CrappyString()
	{
		buffer = 0;
		length = 0;
	}

	CrappyString(const char *Source)
	{
		buffer = 0;
		length = 0;
		Duplicate(Source);
	}

	bool Equals(const char *Source)
	{
		if (!Source)
			return buffer == 0;

		return strcmp(buffer, Source) == 0;
	}

	bool StartsWith(const char *Source)
	{
		if (!Source)
			return buffer == 0;

		return strncmp(buffer, Source, length) == 0;
	}

	char* Duplicate(const char *Source)
	{
		destroy();

		if (!Source)
			return destroy();

		length = strlen(Source);
		buffer = new char[length + 1];
		if (!buffer)
			return destroy();

		strcpy(buffer, Source);
		buffer[length] = 0;

		return buffer;
	}

	char* MakeString(const char *String1, const char *String2)
	{
		destroy();

		length = 0;
		length += String1 ? strlen(String1) : 0;
		length += String2 ? strlen(String2) : 0;

		buffer = new char[length + 1];
		if (!buffer)
			return destroy();

		buffer[0] = 0;

		if (String1)
			strcat(buffer, String1);
		if (String2)
			strcat(buffer, String2);

		return buffer;
	}

	~CrappyString()
	{
		destroy();
	}

	int Length()
	{
		return length;
	}

	const char* Buffer()
	{
		return buffer;
	}

	operator const char*()
	{
		return buffer;
	}
	operator char*()
	{
		return buffer;
	}

	char operator[](const int index)
	{
		if (!buffer || index < 0 || index >= length)
			return 0;

		return buffer[index];
	}
};

#endif
